//**********************************************************
// Program: Abteditor
//
// Author: Charles Marquet
//
// Description: This program reads the Abt SR matrix and 
//              outputs it as another csv file.
//              It adds the missing 0 rows.
//
// Input: The SR.csv file from Abtprepare.java
//
// Need the free csv reader/writer from: http://sourceforge.net/projects/javacsv/
//*********************************************************

import java.io.*;
import java.lang.String;
import java.lang.Math;
import java.lang.Integer;
import com.csvreader.CsvReader;
import com.csvreader.CsvWriter;

public class Abteditor {
  
  private static final String ADDRESS_FILE="SRp.csv";
  
  public static void main(String[] args) throws IOException {
    int county1 = 0;
    int county2 = 0;
    //to keep track of missing rows
    int missing = 0;
    int oldc1 = 0;
    int oldc2 = 0;
    //to keep track of written rows
    int rec = 0;
    
    CsvReader reader = new CsvReader(new FileReader(ADDRESS_FILE));
    
    String [] nextLine;
    int num = 1010000;
    int zero = 0;
    //keep track of current row
    int i = 1; int j = 0; int t=1;
    
    StringWriter sw = new StringWriter();
    //output file
    CsvWriter writer = new CsvWriter("out.csv");
    writer.setDelimiter(',');
    
    while (reader.readRecord()){
      // nextLine[] is an array of values from the line
      // update the indexes
      nextLine = reader.getValues();
      j++;
      if(j>3080){
        j=1;
        t++;
        
        if (t>4){
          t=1;i++;
          //keep track of progress
          System.out.println(i+"/3080");
          //write to file
          writer.flush();
        }
        if(t==4){
          num=1000000+10000*t+i;
        }
        else{
          num=1000000+10000*t;
        }
      }
           
      //get current's line actual indexes
      try{
        county1= Integer.parseInt(nextLine[1]);
        county2= Integer.parseInt(nextLine[2]);
      }
      catch(NumberFormatException e) {
        county1=i;
        county2=1;
        if(t==4){
          county1++;
        }
      }
      // Try writing line to csv if indexes match
      if (county1==i && county2==j ){
        writer.writeRecord(nextLine);
        rec++;
        oldc1=county1;
        oldc2=county2;      
      }
      else{
        //insert missing 0 rows
        while (county1!=i||county2!=j){
          String[] a={""+num,""+i,""+j,"0","0","0","0"};
          writer.writeRecord(a);
          missing++;
          rec++;
          
          j++;
          if(j>3080){
            j=1;
            t++;
            if (t>4){
              t=1;i++;
            }
            if(t==4){
              num=1000000+10000*t+i;
            }
            else{
              num=1000000+10000*t;
            }
            
          }
        }
        writer.writeRecord(nextLine);
        rec++;

      }  
    }
    
    //insert last missing 0 rows
    j++;
    while (j<3081){
      String[] a={""+num,""+i,""+j,"0","0","0","0"};
      writer.writeRecord(a);
      missing++;
      rec++; 
      j++;
    }
    
    
    System.out.println("Missing rows added: "+missing);
    writer.flush();
    writer.close();
    System.out.println("# records: "+rec);

  }
}
