//**********************************************************
// Program: Abtprepare
//
// Author: Charles Marquet
//
// Description: This program reads the Abt SR matrix and 
//              outputs it as another csv file.
//              It adds a row if entire types for a source county are missing.
//
// Input: The SRMatrix from Abtremoveduplicates.java
//
// Need the free csv reader/writer from: http://sourceforge.net/projects/javacsv/
//*********************************************************
import java.io.*;
import java.lang.String;
import java.lang.Math;
import java.lang.Integer;
import com.csvreader.CsvReader;
import com.csvreader.CsvWriter;

public class Abtprepare {
  
  private static final String ADDRESS_FILE="SR.csv";
  
  public static void main(String[] args) throws IOException {
    //indexes to keep track of the types
    int type =0;
    int oldtype=0;
    
    int added = 0;
    int num=0;

    CsvReader reader = new CsvReader(new FileReader(ADDRESS_FILE));
    
    String [] nextLine;
    
    StringWriter sw = new StringWriter();
    //output file
    CsvWriter writer = new CsvWriter("SRp.csv");
    writer.setDelimiter(',');
    
    while (reader.readRecord()){
      // nextLine[] is an array of values from the line
      nextLine = reader.getValues();
      //get types
      type = (int)Math.floor((Integer.parseInt(nextLine[0])-1000000)/10000.0);
      //write a row if missing a whole stack height type 
      if(type-oldtype==2){
        num=1000000+10000*(type-1);
        String[] a={""+num,nextLine[1],"1","0","0","0","0"};
        writer.writeRecord(a);
        added++;
      }
      else if (type-oldtype>2){
        System.out.println("error, need to change code, more than one entire stack height type missing in a county");
      }
      writer.writeRecord(nextLine);
      writer.flush();
      oldtype=type;
    }
    writer.flush();
    writer.close();
    System.out.println("added rows: "+added);
  }
}

