//**********************************************************
// Program: Abtremoveduplicates
//
// Author: Charles Marquet
//
// Description: This program reads the Abt SR matrix and 
//              outputs it as another csv file.
//              It removes duplicate rows for the data
//
// Input: The SRMatrix (Abt csv data file)
//
// Need the free csv reader/writer from: http://sourceforge.net/projects/javacsv/
//*********************************************************
import java.io.*;
import java.lang.String;
import java.lang.Math;
import java.lang.Integer;
import com.csvreader.CsvReader;
import com.csvreader.CsvWriter;

public class Abtremoveduplicates {
  
  private static final String ADDRESS_FILE="SRMatrix_2010_2015.csv";
  
  public static void main(String[] args) throws IOException {
    //indexes to keep track of the counties
    int county1 = 0;
    int county2 = 0;
    int oldc1 = 0;
    int oldc2 = 0;
    
    int duplicates = 0;
    int track =0;
    
    CsvReader reader = new CsvReader(new FileReader(ADDRESS_FILE));
    
    String [] nextLine;
    
    StringWriter sw = new StringWriter();
    //output file
    CsvWriter writer = new CsvWriter("SR.csv");
    writer.setDelimiter(',');
    //skip first line (header)
    reader.skipRecord();
    
    while (reader.readRecord()){
      // nextLine[] is an array of values from the line
      nextLine = reader.getValues();
      //get county numbers
      try{
        county1= Integer.parseInt(nextLine[1]);
        county2= Integer.parseInt(nextLine[2]);
      }
      catch(NumberFormatException e) {
        county1=0;
        county2=0;
      }
      //write to output file if line is not a duplicate
      if(county1==oldc1&&county2==oldc2){
        duplicates++;
      }
      else{
        writer.writeRecord(nextLine);
        oldc1=county1;
        oldc2=county2;   
      }
    }
    System.out.println("removed duplicates: "+duplicates);
  }
}

