function [C] = voltagesorting(A,B)
%% This function sorts the buses from bus match according to the voltage
%% A has bus numbers (from excel file Vsor Input output, Sheet Vol Input, First range)
%% B has Voltage of each bus (from excel file Vsor Input output, Sheet Vol Input, Second range)

X = zeros(1,size(A,2));
C = [];
for a = 1:length(A)
    S = A(a,:);
    Q = B(a,:);
    [t,Ix] = sort(Q,'descend');     %Sorts based on voltage
    for b = 1:size(A,2)
        X(1,b) = S(Ix(b));
    end
    C = cat(1,C,X);
end
end
